Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jdbc.core
Class BeanPropertyRowMapper<T>

    java.lang.Object
      org.springframework.jdbc.core.BeanPropertyRowMapper<T>

All Implemented Interfaces:
  RowMapper<T>

Direct Known Subclasses:
  ParameterizedBeanPropertyRowMapper

    public class BeanPropertyRowMapper<T>

extends java.lang.Object
implements RowMapper<T>

`RowMapper` implementation that converts a row into a new instance of the specified mapped target class. The mapped target class must be a top-level class and it must have a default or no-arg constructor.

Column values are mapped based on matching the column name as obtained from result set metadata to public setters for the corresponding properties. The names are matched either directly or by transforming a name separating the parts with underscores to the same name using "camel" case.

Mapping is provided for fields in the target class for many common types, e.g.: String, boolean, Boolean, byte, Byte, short, Short, int, Integer, long, Long, float, Float, double, Double, BigDecimal, `java.util.Date`, etc.

To facilitate mapping between columns and fields that don't have matching names, try using column aliases in the SQL statement like "select fname as first_name from customer".

For 'null' values read from the databasem, we will attempt to call the setter, but in the case of Java primitives, this causes a TypeMismatchException. This class can be configured (using the primitivesDefaultedForNullValue property) to trap this exception and use the primitives default value. Be aware that if you use the values from the generated bean to update the database the primitive value will have been set to the primitive's default value instead of null.

Please note that this class is designed to provide convenience rather than high performance. For best performance consider using a custom RowMapper.

Since:
  2.5
Author:
  Thomas Risberg, Juergen Hoeller

Field Summary
`protected org.apache.commons.logging.Log` | `logger` Logger available to subclasses

Constructor Summary
`BeanPropertyRowMapper()` Create a new BeanPropertyRowMapper for bean-style configuration.
`BeanPropertyRowMapper(java.lang.Class<T> mappedClass)` Create a new BeanPropertyRowMapper, accepting unpopulated properties in the target bean.
`BeanPropertyRowMapper(java.lang.Class<T> mappedClass, boolean checkFullyPopulated)` Create a new BeanPropertyRowMapper.

Method Summary
`protected java.lang.Object` | `getColumnValue(java.sql.ResultSet rs, int index, java.beans.PropertyDescriptor pd)` Retrieve a JDBC object value for the specified column.
`java.lang.Class<T>` | `getMappedClass()` Get the class that we are mapping to.
`protected void` | `initBeanWrapper(BeanWrapper bw)` Initialize the given BeanWrapper to be used for row mapping.
`protected void` | `initialize(java.lang.Class<T> mappedClass)` Initialize the mapping metadata for the given class.
`boolean` | `isCheckFullyPopulated()` Return whether we're strictly validating that all bean properties have been mapped from corresponding database fields.
`boolean` | `isPrimitivesDefaultedForNullValue()` Return whether we're defaulting Java primitives in the case of mapping a null value from corresponding database fields.
`T` | `mapRow(java.sql.ResultSet rs, int rowNumber)` Extract the values for all columns in the current row.
`static
`<T> BeanPropertyRowMapper<T>`
` | `newInstance(java.lang.Class<T> mappedClass)` Static factory method to create a new BeanPropertyRowMapper (with the mapped class specified only once).
`void` | `setCheckFullyPopulated(boolean checkFullyPopulated)` Set whether we're strictly validating that all bean properties have been mapped from corresponding database fields.
`void` | `setMappedClass(java.lang.Class<T> mappedClass)` Set the class that each row should be mapped to.
`void` | `setPrimitivesDefaultedForNullValue(boolean primitivesDefaultedForNullValue)` Set whether we're defaulting Java primitives in the case of mapping a null value from corresponding database fields.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### logger

    protected final org.apache.commons.logging.Log logger

  Logger available to subclasses

Constructor Detail

### BeanPropertyRowMapper

    public BeanPropertyRowMapper()

  Create a new BeanPropertyRowMapper for bean-style configuration.

  See Also:
    `setMappedClass(java.lang.Class)`, `setCheckFullyPopulated(boolean)`

### BeanPropertyRowMapper

    public BeanPropertyRowMapper(java.lang.Class<T> mappedClass)

  Create a new BeanPropertyRowMapper, accepting unpopulated properties in the target bean.

  Consider using the `newInstance(java.lang.Class)` factory method instead, which allows for specifying the mapped type once only.

  Parameters:
    `mappedClass` - the class that each row should be mapped to

### BeanPropertyRowMapper

    public BeanPropertyRowMapper(java.lang.Class<T> mappedClass,
                                 boolean checkFullyPopulated)

  Create a new BeanPropertyRowMapper.

  Parameters:
    `mappedClass` - the class that each row should be mapped to
    `checkFullyPopulated` - whether we're strictly validating that all bean properties have been mapped from corresponding database fields

Method Detail

### setMappedClass

    public void setMappedClass(java.lang.Class<T> mappedClass)

  Set the class that each row should be mapped to.

### initialize

    protected void initialize(java.lang.Class<T> mappedClass)

  Initialize the mapping metadata for the given class.

  Parameters:
    `mappedClass` - the mapped class.

### getMappedClass

    public final java.lang.Class<T> getMappedClass()

  Get the class that we are mapping to.

### setCheckFullyPopulated

    public void setCheckFullyPopulated(boolean checkFullyPopulated)

  Set whether we're strictly validating that all bean properties have been mapped from corresponding database fields.

  Default is `false`, accepting unpopulated properties in the target bean.

### isCheckFullyPopulated

    public boolean isCheckFullyPopulated()

  Return whether we're strictly validating that all bean properties have been mapped from corresponding database fields.

### setPrimitivesDefaultedForNullValue

    public void setPrimitivesDefaultedForNullValue(boolean primitivesDefaultedForNullValue)

  Set whether we're defaulting Java primitives in the case of mapping a null value from corresponding database fields.

  Default is `false`, throwing an exception when nulls are mapped to Java primitives.

### isPrimitivesDefaultedForNullValue

    public boolean isPrimitivesDefaultedForNullValue()

  Return whether we're defaulting Java primitives in the case of mapping a null value from corresponding database fields.

### mapRow

    public T mapRow(java.sql.ResultSet rs,
                    int rowNumber)
             throws java.sql.SQLException

  Extract the values for all columns in the current row.

  Utilizes public setters and result set metadata.

  Specified by:
    `mapRow` in interface `RowMapper<T>`
  Parameters:
    `rs` - the ResultSet to map (pre-initialized for the current row)
    `rowNumber` - the number of the current row
  Returns:
    the result object for the current row
  Throws:
    `java.sql.SQLException` - if a SQLException is encountered getting column values (that is, there's no need to catch SQLException)
  See Also:
    `ResultSetMetaData`

### initBeanWrapper

    protected void initBeanWrapper(BeanWrapper bw)

  Initialize the given BeanWrapper to be used for row mapping. To be called for each row.

  The default implementation is empty. Can be overridden in subclasses.

  Parameters:
    `bw` - the BeanWrapper to initialize

### getColumnValue

    protected java.lang.Object getColumnValue(java.sql.ResultSet rs,
                                              int index,
                                              java.beans.PropertyDescriptor pd)
                                       throws java.sql.SQLException

  Retrieve a JDBC object value for the specified column.

  The default implementation calls `JdbcUtils.getResultSetValue(java.sql.ResultSet, int, Class)`. Subclasses may override this to check specific value types upfront, or to post-process values return from `getResultSetValue`.

  Parameters:
    `rs` - is the ResultSet holding the data
    `index` - is the column index
    `pd` - the bean property that each result object is expected to match (or `null` if none specified)
  Returns:
    the Object value
  Throws:
    `java.sql.SQLException` - in case of extraction failure
  See Also:
    `JdbcUtils.getResultSetValue(java.sql.ResultSet, int, Class)`

### newInstance

    public static <T> BeanPropertyRowMapper<T> newInstance(java.lang.Class<T> mappedClass)

  Static factory method to create a new BeanPropertyRowMapper (with the mapped class specified only once).

  Parameters:
    `mappedClass` - the class that each row should be mapped to

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD